/*
 * Demonstration program for Nano-X blitting
 */
#include <stdio.h>
#include <stdlib.h>
#include "nano-X.h"
#include "device.h"

static	GR_WINDOW_ID	w1;		/* id for large window */
static	GR_GC_ID	gc1;		/* graphics context for text */
static	GR_GC_ID	gc2;		/* graphics context for text */
static	GR_SCREEN_INFO	si;		/* information about screen */

void errorcatcher();			/* routine to handle errors */


#define GRAY14		RGB( 17, 17, 17 )
#define GRAY13		RGB( 34, 34, 34 )
#define GRAY12		RGB( 51, 51, 51 )
#define GRAY11		RGB( 68, 68, 68 )
#define GRAY10		RGB( 85, 85, 85 )
#define GRAY9		RGB( 102, 102, 102 )
#define GRAY8		RGB( 119, 119, 119 )
#define GRAY7		RGB( 136, 136, 136 )
#define GRAY6		RGB( 153, 153, 153 )
#define GRAY5		RGB( 170, 170, 170 )
#define GRAY4		RGB( 187, 187, 187 )
#define GRAY3		RGB( 204, 204, 204 )
#define GRAY2		RGB( 221, 221, 221 )
#define GRAY1		RGB( 238, 238, 238 )


int
main(int argc,char **argv)
{
	GR_EVENT	event;		/* current event */

	if (GrOpen() < 0) {
		fprintf(stderr, "cannot open graphics\n");
		exit(1);
	}
	
	GrGetScreenInfo(&si);

	GrSetErrorHandler(errorcatcher);

//	w1 = GrNewWindow(GR_ROOT_WINDOW_ID, 99, 49, 440, 380, 4, BLACK, WHITE);

//	GrMapWindow(w1);

	gc1 = GrNewGC();
//	gc2 = GrNewGC();

	GrSetGCForeground(gc1, WHITE);
//	GrFillRect(GR_ROOT_WINDOW_ID, gc, 0, 0, 240, 320);

	GrLine(GR_ROOT_WINDOW_ID, gc1, 4, 4, 634, 4);
	GrLine(GR_ROOT_WINDOW_ID, gc1, 4, 4, 4, 474);
	GrLine(GR_ROOT_WINDOW_ID, gc1, 634, 4, 634, 474);
	GrLine(GR_ROOT_WINDOW_ID, gc1, 4, 474, 634, 474);

//	GrJPEG(w1, gc2, 0, 0, 400, 400, "/home/mart/nov9_pic1.jpg");

// Bitblit function
{
	PSD	mempsd;
	int	linelen, size;
	void *	pixels;
	
	mempsd = scrdev.AllocateMemGC(&scrdev);
	GdCalcMemGCAlloc(mempsd, 50, 100, 0, 0, &size, &linelen);
	pixels = malloc(size);
	mempsd->flags |= PSF_ADDRMALLOC;
	mempsd->MapMemGC(mempsd, 50, 100, scrdev.planes, scrdev.bpp,
		linelen, size, pixels);

	// Draw some stuff on offscreen
	GdSetForeground(GdFindColor(GREEN));
	GdFillRect(mempsd, 0, 0, 50, 100);
	GdSetForeground(GdFindColor(RED));
	GdFillRect(mempsd, 5, 20, 40, 60);

	// blit
	GdBlit(&scrdev, 10, 10, 50, 100, mempsd, 0, 0, 0);
}
/*	GrSetGCForeground(gc, BLACK);
	GrPoint(GR_ROOT_WINDOW_ID, gc, 0, 0);

	GrSetGCForeground(gc, GRAY10);
	GrFillRect(GR_ROOT_WINDOW_ID, gc, 1, 1, 478, 638);
*/
	while (1) {GrCheckNextEvent(&event);}

	return 0;
}



/*
 * Here on an unrecoverable error.
 */
void
errorcatcher(code, name, id)
	GR_ERROR	code;		/* error code */
	GR_FUNC_NAME	name;		/* function name which failed */
	GR_ID		id;		/* resource id */
{
	GrClose();
	fprintf(stderr, "DEMO ERROR: code %d, function %s, resource id %d\n",
		code, name, id);
	exit(1);
}
